var SPOV = function() { //create namespace
  var imgSize = 0;
  var imgIndex = null;
  var funcType = 0;  
  var imgCnt = 0;
  var imgCntDec = 0;
}

var imgList;
var sizeList = new Array();
var docList = new Array();
var p2 = 0;

const nsIPermissionManager = Components.interfaces.nsIPermissionManager;

//var SPOVAlertNotif = Components.classes['@mozilla.org/alerts-service;1'].getService(Components.interfaces.nsIAlertsService).showAlertNotification;

// load the permission manager:
var _pm  = Components.classes['@mozilla.org/permissionmanager;1'].getService(Components.interfaces.nsIPermissionManager);
var _prefs = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranch);
var ioService = Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService);

var restore_block_host;
var oldvalue

// Returns true if anything is selected.
SPOV.isContentSelected = function() {
  return !document.commandDispatcher.focusedWindow.getSelection().isCollapsed;
}

SPOV.showhideShowPicture = function() {
  var prefManager = _prefs.getBranch('extensions.showPicture.');
  var hide = !(document.popupNode instanceof Components.interfaces.nsIImageLoadingContent && document.popupNode.currentURI) ||
      !prefManager.getBoolPref('chkShowPicture');
  document.getElementById('idShowPicture').setAttribute('hidden',hide);
  hide = !prefManager.getBoolPref('chkShowAllPictures');
  document.getElementById('idShowAllPictures').setAttribute('hidden',hide);
  document.getElementById('idShowAllPicturesV').setAttribute('hidden',hide);
  var sel = SPOV.isContentSelected();
  hide = !sel || !prefManager.getBoolPref('chkShowSelPictures');
  document.getElementById('idShowSelPictures').setAttribute('hidden',hide);
  document.getElementById('idShowSelPicturesV').setAttribute('hidden',hide);
  hide = !prefManager.getBoolPref('chkEnlarge');
  document.getElementById('idEnlarge').setAttribute('hidden',hide);
  document.getElementById('idEnlargeV').setAttribute('hidden',hide);
  hide = !prefManager.getBoolPref('chkShowLargest');
  document.getElementById('idShowLargest').setAttribute('hidden',hide);
  hide = !prefManager.getBoolPref('chkShowLargestEach');
  document.getElementById('idShowLargestEach').setAttribute('hidden',hide);
}

SPOV.allowImages = function() {
  // turn on image loading, so we can actually load the image
  // if the user has image loading off...
  oldvalue = _prefs.getIntPref('permissions.default.image');
  _prefs.setIntPref('permissions.default.image',1);
}

SPOV.checkBlocking = function(imgNode) {
  restore_block_host = '';
  // Check to see if this url is blocked
  if (_pm.testPermission(imgNode.currentURI,'image') == nsIPermissionManager.DENY_ACTION) {
    _pm.remove(imgNode.currentURI.host, 'image');
    restore_block_host = imgNode.currentURI.host;
  }
}

SPOV.restoreBlocking = function() {
  var uri = ioService.newURI('http://'+restore_block_host, null, null);
  _pm.add(uri,'image',nsIPermissionManager.DENY_ACTION);
}

SPOV.revealPicture = function(imgNode) {
  try {
    if (!(imgNode instanceof Components.interfaces.nsIImageLoadingContent) || !imgNode.currentURI) {
       return;
    }
  } catch (ex) {
    return;
  }
  SPOV.checkBlocking(imgNode);
  imgNode.src = imgNode.src; // trigger the image load
  if (restore_block_host) // turn back on the host block if necessary
    SPOV.restoreBlocking();
}

SPOV.checkDuplicates = function(srcURL) {
  var imgs = content.document.images;
  if (imgs && imgs.length) {
    for (var i = 0; i < imgs.length; ++i) {
      if (imgs[i].src == srcURL)
        SPOV.revealPicture(imgs[i]);
    } 
  }
}

// rather then check all images against all other images, check if image already loaded
SPOV.ImageAlreadyLoaded = function(image) { //Check if current image is already loaded
	if (image instanceof Components.interfaces.nsIImageLoadingContent) {			// Important check
		var request = image.getRequest (Components.interfaces.nsIImageLoadingContent.CURRENT_REQUEST);
	  return !(request && (request.imageStatus & request.STATUS_SIZE_AVAILABLE));
	}
	else
		return false;
}

SPOV.doShowPicture = function() {
  SPOV.allowImages();
  SPOV.revealPicture(document.popupNode);
  SPOV.checkDuplicates(document.popupNode.src);
  if (oldvalue != 1) // restore image setting
    _prefs.setIntPref('permissions.default.image',oldvalue);
}

SPOV.doShowSelPictures = function() {
  //var selOffset = content.getSelection().focusOffset;
  //if (selOffset > 0) {
  var sel = SPOV.isContentSelected();
  if (sel) {
    var selection = content.getSelection();
    var imgs = content.document.images;
    if (imgs && imgs.length) {
      SPOV.allowImages();
      for (var i = 0; i < imgs.length; ++i) {
        if (selection.containsNode(imgs[i], true)) {
          //SPOV.revealPicture(imgs[i]);
          SPOV.checkDuplicates(imgs[i].src); //revealPicture done in checkDuplicates
        }
      } //for
      if (oldvalue != 1) // restore image setting
        _prefs.setIntPref('permissions.default.image',oldvalue);
    } //if imgs.length
    selection.collapseToStart();
  }
}

SPOV.doEnlargePlaceholders = function() {
  var imgs = content.document.images;
  if (imgs && imgs.length) {
    for (var i = 0; i < imgs.length; ++i) {
      if ((imgs[i].width < 3) || (imgs[i].height < 3)) {
        imgs[i].setAttribute('width',10);
        imgs[i].setAttribute('height',10);
        //imgs[i].setAttribute('background','red');
      }
    }
  }
}

SPOV.doShowAllPictures = function(fType) { // restore all img tags
  SPOV.funcType = fType;
  SPOV.imgSize = 0;
  SPOV.imgIndex = null;
  SPOV.imgCnt = 0;
  SPOV.imgCntDec = 0;
  p2 = 0;
  docList.length = 0; //clear list
  SPOV.allowImages();
  var i = gBrowser.tabContainer.selectedIndex;
  switch (SPOV.funcType) {
    case 0: { //all pictures
      SPOV.StepFrames(gBrowser.getBrowserAtIndex(i).contentDocument); //step through frames (if any) finding images
      break;
    }
    case 1: { //largest in current document
      imgList = document.popupNode.ownerDocument.images;
      if (imgList) {
        sizeList.length = imgList.length;
        SPOV.doAllPics(); //do main document
      }
      break;
    }
    case 2: { //largest in each frame
      SPOV.StepFrames(gBrowser.getBrowserAtIndex(i).contentDocument); //step through frames (if any) creating list of docs
      //alert('docList.length= '+docList.length);
      p2 = -1; //reset to start of list
      SPOV.getNextImgList();
      if (imgList) {
        sizeList.length = imgList.length;
        SPOV.doAllPics(); //find image in first imgList - doGetSize then continues through other docs
      }
      break;
    }
  } //switch
  if (oldvalue != 1) { // restore image setting
    _prefs.setIntPref('permissions.default.image',oldvalue);
  }
}

SPOV.getNextImgList = function() {
  do {
    p2++;
    if (docList[p2])
      imgList = docList[p2].images;                    
    else
      imgList = null; //set to null else has old value
    if (p2 >= docList.length)
      break;
  } while ((imgList == null) || (imgList.length == 0));
}

SPOV.doAllPics = function() {
  if (imgList && imgList.length) {
    imgCnt = imgList.length;
    imgCntDec = imgCnt;
    for (var i = 0; i < imgList.length; ++i) {
      switch (SPOV.funcType) {
        case 0: { //show all
          SPOV.revealPicture(imgList[i]);
          break;
        }
        case 1:   //show largest
        case 2: { //show largest each frame
          SPOV.doGetSize(imgList[i].src);
        } //case
      }
    } //for
  }
}

SPOV.GetIFrameDocument = function(fr) {
  var doc;
  if (fr.contentDocument) // For NS6
    doc = fr.contentDocument; 
  else
    if (fr.contentWindow) // For IE5.5 and IE6
      doc = fr.contentWindow.document;
    else
      if (fr.document) // For IE5
        doc = fr.document;
      else //other browser
        doc = fr.document;     
  return doc;
}

SPOV.StepFrames = function(contDoc) {
  if ((SPOV.funcType == 0) && (contDoc)) { //all pics
    imgList = contDoc.images;
    SPOV.doAllPics(); //do main document
  } else {
    docList[p2++] = contDoc;
  }
  try {
    var FrameArr = contDoc.getElementsByTagName('frame');
  }
  catch(e){}
  try {
    var iFrameArr = contDoc.getElementsByTagName('iframe');
  }
  catch(e){}
  var fCD;
  if (FrameArr)
    if (FrameArr.length > 0) {
	  	for (var i = 0 ; i< FrameArr.length ; i++) {
		  	fCD = SPOV.GetIFrameDocument(FrameArr[i]);
		  	if (fCD)
			    SPOV.StepFrames(fCD); // recursion for frames
  		}
	  }
	if (iFrameArr)
  	if (iFrameArr.length > 0)	{
	  	for (var i = 0 ; i < iFrameArr.length ; i++) {
		  	fCD = SPOV.GetIFrameDocument(iFrameArr[i]);
		  	if (fCD)
  			  SPOV.StepFrames(fCD); // recursion for iframes
	  	}
	  }
}

SPOV.getExt = function(imgURL) {
  var reImg = /(\.(jpg|gif|png|bmp|jpeg))/i;  // file extension could be anywhere in the URL
  var ar = reImg.exec(imgURL);
  if (ar)
    return ar[1].toLowerCase();
  else
    return '';
}

SPOV.revealLargest = function() {
  SPOV.allowImages();
  var tempSize = 0;
  var imgExt;
  for (var i = 0; i < imgCnt; i++) {
    tempSize = sizeList[i];
    if (tempSize > SPOV.imgSize) {
      imgExt = SPOV.getExt(imgList[i].src); // get the extension
      //alert('imgList[i].src - '+imgList[i].src+'\n imgExt - '+imgExt);
      if ((imgExt == '.jpeg') || (imgExt == '.jpg')) {
        //alert('SPOV.imgSize - '+SPOV.imgSize+'\n SPOV.imgIndex - '+SPOV.imgIndex);
        SPOV.imgSize = tempSize;
        SPOV.imgIndex = imgList[i];
      }
    }
  } //for
  if (SPOV.imgIndex)
    SPOV.revealPicture(SPOV.imgIndex);
  SPOV.imgSize = 0; //reset values
  SPOV.imgIndex = null;
  sizeList.length = 0; //clear list
  if (oldvalue != 1) { // restore image setting
    _prefs.setIntPref('permissions.default.image',oldvalue);
  }
}

SPOV.doGetSize = function(url) {
  var httpRequest;
  httpRequest = new XMLHttpRequest();
  if (!httpRequest) {
    return 0;
  }
  httpRequest.onreadystatechange = function() {
    if (httpRequest.readyState == 4) {
      if ((httpRequest.status == 200) || (httpRequest.status == 404)) {
        //try {
        for (var i = 0; i < imgCnt; i++)
          if (url == imgList[i].src) {
            if (httpRequest.status == 200) {
              var size = parseInt(httpRequest.getResponseHeader('Content-Length'));
              sizeList[i] = size;
            } else {
              sizeList[i] = 0;
            }
          }
        imgCntDec--;
        if (imgCntDec == 0) {
          SPOV.revealLargest();
          if (SPOV.funcType == 2) { //largest in each frame
            //SPOVAlertNotif('', 'doing next doc p2= '+p2, '', false, null, null);
            if (p2 < docList.length) {
              SPOV.getNextImgList();
              if (imgList) {
                sizeList.length = imgList.length;
                SPOV.doAllPics(); //do main document
              }
            }
          }
        }
        /*} catch (ex) {
          alert('catch httpRequest.status= '+httpRequest.status+'\np2= '+p2)
          return;
        }*/
      } else {
        alert('httpRequest.status= '+httpRequest.status+'\np2= '+p2)
        return;
      }
    }
  };
  httpRequest.open('HEAD', url, true);
  httpRequest.send(null);
}

SPOV.changeImage = function(Toggle) {
	if (!Toggle) {
		Toggle = _prefs.getIntPref('permissions.default.image');
	}
	if (Toggle == 1) {
    document.getElementById('btnImagesOnOff').image = 'chrome://showpicture/skin/on.png';
    document.getElementById('idImagesOnOffV').setAttribute('checked',true);
    document.getElementById('idImagesOnOff').setAttribute('checked',true);
  } else {
    document.getElementById('btnImagesOnOff').image = 'chrome://showpicture/skin/off.png';
    document.getElementById('idImagesOnOffV').setAttribute('checked',false);
    document.getElementById('idImagesOnOff').setAttribute('checked',false);
  }
}

SPOV.doImagesOnOff = function() {
  var Toggle = 3 - _prefs.getIntPref('permissions.default.image');
  if (Toggle in [0,3]) //prevent incorrect values
  	Toggle = 1;
  _prefs.setIntPref('permissions.default.image',Toggle); //by setting the pref, oberve is called, changing the icon
}

var spov_PrefObserver = {
  register: function() {
    var Prefs = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefBranchInternal);
    this.spovBranch = Prefs.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
    this.spovBranch.addObserver('', this, false);
    SPOV.changeImage(0);
  },

  unregister: function() {
    if(this.spovBranch)
	    this.spovBranch.removeObserver('', this);
  },

  //aSubject is the nsIPrefBranch
  //aData is the name of the pref that's been changed
  observe: function(aSubject,aTopic,aData) {
    if(aTopic != 'nsPref:changed')
    	return;
    switch (aData) {
      case 'permissions.default.image':
	  		SPOV.changeImage(0);
        break;
    } //switch
  } //observe
}

function initfunc() {
  var contextmenu = document.getElementById('contentAreaContextMenu');
	if (contextmenu)
	  contextmenu.addEventListener('popupshowing', SPOV.showhideShowPicture, false);
	spov_PrefObserver.register();
}

function deinitfunc() {
	spov_PrefObserver.unregister();
}

window.addEventListener('load', initfunc, false);
window.addEventListener('unload',deinitfunc,false);